;;  IMPORTANTE
;;  #_hola      -> Hacemos referencia a la direccion de memoria
;;  (_hola)     -> Hacemos referencia al contenido almacenado en esa direccion de memoria

.include "entity.h.s"
.include "sys/render.h.s"
.include "cpctelera.h.s"

sprite_wall:
	.db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00
    .db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00
    .db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00
    .db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00

entity_size     == 15


_num_entities:: .db 0   ;;Num entidades que hay ahora mismo creadas

_last_elem_ptr:: .dw _entity_array

_entity_array:: ;;Etiqueta globarl (::). Llenamos entidades con 0
    .ds max_entities * entity_size

entityman_getEntityArray_IX::
    ld      ix, #_entity_array
    ret

entityman_getNumEntites_A::
    ld      a, (_num_entities)
    ret


DefineEntity player, 44, 88, 4, 8, 0, 0, 0x01, 0x00, 0x00, e_ai_st_no_ai

DefineEntity enemy1, 4, 24, 4, 8, 0, 0, 0x02, 0x00, 0x00, e_ai_st_stand_by
DefineEntity enemy2, 4, 72, 4, 8, 0, 0, 0x02, 0x00, 0x00, e_ai_st_stand_by

DefineEntity bala, 0, 0, 1, 2, 0, 0, 0x20, 0x00, 0x00, e_ai_st_no_ai

DefineEntity balaR, 0, 0, 1, 2, 4, 0, 0x20, 0x00, 0x00, e_ai_st_no_ai
DefineEntity balaL, 0, 0, 1, 2, -4, 0, 0x20, 0x00, 0x00, e_ai_st_no_ai
DefineEntity balaU, 0, 0, 1, 2, 0, -8, 0x20, 0x00, 0x00, e_ai_st_no_ai
DefineEntity balaD, 0, 0, 1, 2, 0, 8, 0x20, 0x00, 0x00, e_ai_st_no_ai
;;X = 48 --> 16*4 + 8 = 64 + 8 = 72
;;Y = A8 --> 168

crear_bala::
    
    ld      hl, #bala
    call man_entity_create

    ld      iy, #_entity_array

    repetir_busqueda:

    ld a, e_type(iy)
    and #e_type_bullet
    jr nz, balas


    ld bc, #entity_size
    add iy, bc

    jr repetir_busqueda


    balas:
    
    ld a, (_my_last_direction)
    cp #4
    jp z, disparo_izq
    ld a, (_my_last_direction)
    cp #6
    jp z, disparo_der
    ld a, (_my_last_direction)
    cp #8
    jp z, disparo_arriba
    ld a, (_my_last_direction)
    cp #2
    jp z, disparo_abajo



;;DISPARO HACIA LA IZQUIERDA
    disparo_izq:
    ld a, e_x(ix)                       ;;Posicion X de nuestro jugador
    ld b, #-4
    add a, b
    ld e_x(iy), a                       ;;Posicion X de la bala
    ld e_vx(iy), #-4                    ;;Velocidad X de la bala
    ;;Centramos la bala en el eje Y
    ld a, e_y(ix)                       ;;Posicion X de nuestro jugador
    ld b, #4
   ; add a, b
    ld e_y(iy), a
    jr termino_disparo


;;DISPARO HACIA LA DERECHA
    disparo_der:
    ld a, e_x(ix)                       ;;Posicion X de nuestro jugador
    ld b, #4
    add a, b
    ld e_x(iy), a                       ;;Posicion X de la bala
    ld e_vx(iy), #4                    ;;Velocidad X de la bala
    ;;Centramos la bala en el eje Y
    ld a, e_y(ix)                       
    ld b, #4
   ; add a, b
    ld e_y(iy), a
    jr termino_disparo

;;DISPARO HACIA ARRIBA
    disparo_arriba:
    ld a, e_y(ix)                       
    ld b, #-8
    add a, b
    ld e_y(iy), a                       
    ld e_vy(iy), #-8                    

    ld a, e_x(ix)                       
    ld b, #1
   ; add a, b
    ld e_x(iy), a
    jr termino_disparo

;;DISPARO HACIA ABAJO
    disparo_abajo:
    ld a, e_y(ix)                       
    ld b, #8
    add a, b
    ld e_y(iy), a                       
    ld e_vy(iy), #8                    

    ld a, e_x(ix)                       
    ld b, #1
   ; add a, b
    ld e_x(iy), a
    

    termino_disparo:



    ret

crear_bala_enemigo:

    ;;ld      hl, #bala
    ;;call man_entity_create
    


    ;;AQUÍ HARÍAMOS UN COMPARE DEL NIVEL PARA SELECCIONAR TIPO DE DISPARO

    ld a, (estado_partida)
    cp #6
    jp z, nivelseis
    cp #7
    jp z, nivelsiete
    cp #8
    jp z, nivelocho
    cp #9
    jp z, nivelnueve
    cp #10
    jp z, niveldiez
    cp #11
    jp z, nivelonce
    cp #12
    jp z, niveldoce
    cp #13
    jp z, niveltrece
    cp #14
    jp z, nivelcatorce
    cp #15
    jp z, nivelquince
    cp #16
    jp z, niveldiezyseis
    cp #17
    jp z, niveldiezysiete
    cp #18
    jp z, niveldiezyocho
    cp #19
    jp z, niveldiezynueve
    cp #20
    jp z, nivelveinte

    jp fin_disparo

    nivelseis:
    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #40
    ld e_x(ix),a
    ld e_y(ix),b

    ;;ld      hl, #balaR
    ;;call man_entity_create
;;
    ;;ld      ix, (_last_elem_ptr)
    ;;ld      bc, #-entity_size
    ;;add     ix, bc
;;
    ;;ld a, #20
    ;;ld b, #136
    ;;ld e_x(ix),a
    ;;ld e_y(ix),b
;;
    ;;ld      hl, #balaL
    ;;call man_entity_create
;;
    ;;ld      ix, (_last_elem_ptr)
    ;;ld      bc, #-entity_size
    ;;add     ix, bc
;;
    ;;ld a, #60
    ;;ld b, #80
    ;;ld e_x(ix),a
    ;;ld e_y(ix),b

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #64
    ld b, #152
    ld e_x(ix),a
    ld e_y(ix),b
    
    jp fin_disparo

    nivelsiete:

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #152
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo
    nivelocho:

    ld      hl, #balaU
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #40
    ld b, #152
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaD
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #36
    ld b, #32
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo
    nivelnueve:

    ;;ld      hl, #balaD
    ;;call man_entity_create
;;
    ;;ld      ix, (_last_elem_ptr)
    ;;ld      bc, #-entity_size
    ;;add     ix, bc
;;
    ;;ld a, #72
    ;;ld b, #32
    ;;ld e_x(ix),a
    ;;ld e_y(ix),b

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #68
    ld b, #168
    ld e_x(ix),a
    ld e_y(ix),b

    ;;ld      hl, #balaR
    ;;call man_entity_create
;;
    ;;ld      ix, (_last_elem_ptr)
    ;;ld      bc, #-entity_size
    ;;add     ix, bc
;;
    ;;ld a, #8
    ;;ld b, #24
    ;;ld e_x(ix),a
    ;;ld e_y(ix),b

    ld      hl, #balaU
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #4
    ld b, #160
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo
    niveldiez:

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #28
    ld b, #160
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #68
    ld b, #168
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo
    nivelonce:
    niveldoce:

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #68
    ld b, #40
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaD
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #20
    ld b, #88
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaD
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #12
    ld b, #88
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo
    niveltrece:

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #52
    ld b, #96
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #160
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #168
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo

    nivelcatorce:

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #68
    ld b, #128
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #152
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo

    nivelquince:

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #44
    ld b, #32
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #32
    ld b, #24
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo

    niveldiezyseis:

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #4
    ld b, #24
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaU
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #4
    ld b, #160
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #68
    ld b, #168
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaD
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #72
    ld b, #32
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo

    niveldiezysiete:

    ;;ld      hl, #balaD
    ;;call man_entity_create
;;
    ;;ld      ix, (_last_elem_ptr)
    ;;ld      bc, #-entity_size
    ;;add     ix, bc
;;
    ;;ld a, #28
    ;;ld b, #152
    ;;ld e_x(ix),a
    ;;ld e_y(ix),b

    ld      hl, #balaU
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #4
    ld b, #160
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #32
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaU
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #48
    ld b, #56
    ld e_x(ix),a
    ld e_y(ix),b


    jp fin_disparo

    niveldiezyocho:

    ld      hl, #balaD
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #32
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaR
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #8
    ld b, #128
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaD
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #24
    ld b, #48
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo

    niveldiezynueve:

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #68
    ld b, #32
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo

    nivelveinte:

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #68
    ld b, #24
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaL
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #64
    ld b, #168
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaD
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #32
    ld b, #24
    ld e_x(ix),a
    ld e_y(ix),b

    ld      hl, #balaU
    call man_entity_create

    ld      ix, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     ix, bc

    ld a, #72
    ld b, #160
    ld e_x(ix),a
    ld e_y(ix),b

    jp fin_disparo

    fin_disparo:

ret

;;Creamos el player
man_entity_init::
    ld      a, #0
    ld      (_num_entities), a
    ;;Creamos la tortuga / Tiene que ser la primera creada
    ld      hl, #player
    call man_entity_create
    ;;Creamos 1 huevo


    ld a, (estado_partida)
    cp #1
    jp z, cinco_enemigos
    cp #2
    jp z, cuatro_enemigos
    cp #3
    jp z, tres_enemigos
    cp #4
    jp z, cuatro_enemigos
    cp #5
    jp z, tres_enemigos
    cp #7
    jp z, un_enemigo
    cp #8
    jp z, cinco_enemigos
    cp #9
    jp z, cuatro_enemigos
    cp #10
    jp z, tres_enemigos
    cp #11
    jp z, cuatro_enemigos
    cp #12
    jp z, cuatro_enemigos
    cp #13
    jp z, dos_enemigos
    cp #14
    jp z, cinco_enemigos
    cp #15
    jp z, tres_enemigos
    cp #16
    jp z, dos_enemigos
    cp #17
    jp z, dos_enemigos
    cp #18
    jp z, dos_enemigos
    cp #19
    jp z, tres_enemigos
    cp #20
    jp z, un_enemigo
    cp #21
    jp z, cuatro_enemigos
    
    

    jp no_hay_enemigos

    un_enemigo:
    ld hl, #enemy1
    call man_entity_create
    jr no_hay_enemigos


    dos_enemigos:

    .rept 2
        ld hl, #enemy1
        call man_entity_create
    .endm
    jr no_hay_enemigos

    tres_enemigos:

    .rept 3
        ld hl, #enemy1
        call man_entity_create
    .endm
    jr no_hay_enemigos


    cuatro_enemigos:

    .rept 4
        ld hl, #enemy1
        call man_entity_create
    .endm
    jr no_hay_enemigos

    cinco_enemigos:

    .rept 5
        ld hl, #enemy1
        call man_entity_create
    .endm
    jr no_hay_enemigos

    

    no_hay_enemigos:



    ret


;;Previamente, nos pasan por parametro HL -> Puntero a los bytes de inicializacion (los valores de player)
man_entity_create::


    ld      de, (_last_elem_ptr)
    ld      bc, #entity_size
    ldir                        ;;LDIR = copia de "hl" a "de" tantos bytes como indique bc 

    ld      a, (_num_entities)
    inc     a
    ld      (_num_entities), a

    ld      hl, (_last_elem_ptr)    ;;Cargamos en hl la informacion que hay en _last_elem_ptr, no su direccion de memoria
    ld      bc, #entity_size        ;;Numero de bytes que desplazamos el puntero para alcanzar la sig entidad (13 en nuestro caso)    
    add     hl, bc                  ;;A hl sumamos bc( = 13 ) para alcanzar la sig entidad
    ld      (_last_elem_ptr), hl    ;;Actualizamos el ultimo puntero al valor de hl (ahora hacemos referencia a una nueva entidad)

    ret


;; En hl esta guardada la funcion que se quiere repetir para cada entidad
man_entity_forall::
    ld      a, (_num_entities)
    ld      ix, #_entity_array

setVariables:
    push af
    push hl
    ld bc, #_next_entity
    push bc
    jp (hl)

_next_entity:
    pop hl
    pop af
    dec a 
    ret z

    ld bc, #entity_size
    add ix, bc
    jr setVariables

    ret

man_entity_destroy::

    ld a, #0
    ld (_num_entities),a
    
    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl, bc
    ld      (_last_elem_ptr), hl
    ld__a_iyl
    sub     l
    jr      nz, _copy
    ld__a_iyh
    sub     h
    jr      z, _nocopy

_copy:
    ld__e_iyl
    ld__d_iyh
    ld      bc, #entity_size
    ldir

_nocopy:
    ld      hl, (_last_elem_ptr)
    .rept entity_size
        ld      (hl), #0
        inc     hl
    .endm
    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl, bc 
    ret

    ret

man_entity_destroy_bullet::
    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  e_xant(iy)                       ;;  Posicion x de la entidad
    ld      b,  e_yant(iy)                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ex      de,     hl
    ld      hl, #sprite_wall
    ld      c,      e_w(iy)
    ld      b,      e_h(iy)

    call cpct_drawSprite_asm

    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  e_x(iy)                       ;;  Posicion x de la entidad
    ld      b,  e_y(iy)                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ex      de,     hl
    ld      hl, #sprite_wall
    ld      c,      e_w(iy)
    ld      b,      e_h(iy)

    call cpct_drawSprite_asm

    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl, bc 
                                ;; hl = principio de la última entidad del array
    ld__e_iyl
    ld__d_iyh
                                ;; de = dirección de la entidad a borrar
    ld      bc, #entity_size
                                ;; bc = tmny entidad
    ldir

    ;;borrar la última entidad
  
    .rept entity_size
        ld      (hl), #0
        inc     hl
    .endm

    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl, bc
    ld      (_last_elem_ptr), hl
    ld      bc, #-entity_size
    add     hl, bc 



    ld      a, (_num_entities)
    dec     a
    ld      (_num_entities), a

ret

man_entity_destroy_ix::

    ;;IX TENEMOS DIRECCION DONDE QUEREMOS COPIAR
    ;;copiar last enemy en la posicion que vamos a borrar (ldir)
    ;;LDIR = copia de "hl" a "de" tantos bytes como indique bc 
    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  e_xant(ix)                       ;;  Posicion x de la entidad
    ld      b,  e_yant(ix)                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ex      de,     hl
    ld      hl, #sprite_wall
    ld      c,      e_w(ix)
    ld      b,      e_h(ix)

    call cpct_drawSprite_asm

    ;;ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ;;ld      c,  e_x(ix)                       ;;  Posicion x de la entidad
    ;;ld      b,  e_y(ix)                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    ;;call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla
;;
    ;;ex      de,     hl
    ;;ld      hl, #sprite_wall
    ;;ld      c,      e_w(ix)
    ;;ld      b,      e_h(ix)
;;
    ;;call cpct_drawSprite_asm

    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl, bc 
    push hl
                                ;; hl = principio de la última entidad del array
    ld__e_ixl
    ld__d_ixh
                                ;; de = dirección de la entidad a borrar
    ld      bc, #entity_size
                                ;; bc = tmny entidad
    ldir

    ;;borrar la última entidad
    pop hl
  
    .rept entity_size
        ld      (hl), #0
        inc     hl
    .endm

    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl, bc
    ld      (_last_elem_ptr), hl

    ld      bc, #-entity_size
    add     hl, bc 



    ld      a, (_num_entities)
    dec     a
    ld      (_num_entities), a


ret