;;  IMPORTANTE
;;  #_hola      -> Hacemos referencia a la direccion de memoria
;;  (_hola)     -> Hacemos referencia al contenido almacenado en esa direccion de memoria

.include "cpctelera.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"
.include "man/hud.h.s"
.include "sys/render.h.s"
.include "sys/physics.h.s"
.include "sys/collision.h.s"

_eggs:: .db 0
_vidas:: .db 4
_vidas_ant:: .db 2   ;;Vidas reales + 1

_key:: .db 0

_slip:: .db 2

_num_pal_bucle:: .db 0

_weapont:: .db 0
_recamara:: .db 0

_mapa_actual:: .db 0

_disparo_enemigo:: .db 0

_my_last_direction:: .db 8

;; Macro / update for all entities of each system
.macro SysUpdate sysname
   ld   hl, #sys_'sysname'_update
   call man_entity_forall
.endm

descomprimir_mapa::

   ld a, (estado_partida)
   cp #1
   jp z, descomprimir_0
   cp #2
   jp z, descomprimir_1
   cp #3
   jp z, descomprimir_2
   cp #4
   jp z, descomprimir_3
   cp #5
   jp z, descomprimir_4
   cp #6
   jp z, descomprimir_5
   cp #7
   jp z, descomprimir_6
   cp #8
   jp z, descomprimir_7
   cp #9
   jp z, descomprimir_8
   cp #10
   jp z, descomprimir_9
   cp #11
   jp z, descomprimir_10
   cp #12
   jp z, descomprimir_11
   cp #13
   jp z, descomprimir_12
   cp #14
   jp z, descomprimir_13
   cp #15
   jp z, descomprimir_14
   cp #16
   jp z, descomprimir_15
   cp #17
   jp z, descomprimir_16
   cp #18
   jp z, descomprimir_17
   cp #19
   jp z, descomprimir_18
   cp #20
   jp z, descomprimir_19
   cp #21
   jp z, descomprimir_20
   jp terminar_descomprimir_mapa

   descomprimir_0:

   ld       hl, #_my_level0_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   descomprimir_1:

   ld       hl, #_my_level1_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   descomprimir_2:

   ld       hl, #_my_level2_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   descomprimir_3:

   ld       hl, #_my_level3_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   descomprimir_4:

   ld       hl, #_my_level4_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   descomprimir_5:

   ld       hl, #_my_level5_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   descomprimir_6:

   ld       hl, #_my_level6_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   descomprimir_7:

   ld       hl, #_my_level7_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_8:

   ld       hl, #_my_level8_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_9:

   ld       hl, #_my_level9_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_10:

   ld       hl, #_my_level10_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_11:

   ld       hl, #_my_level11_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_12:

   ld       hl, #_my_level12_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_13:

   ld       hl, #_my_level13_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_14:

   ld       hl, #_my_level14_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_15:

   ld       hl, #_my_level15_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_16:

   ld       hl, #_my_level16_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_17:

   ld       hl, #_my_level17_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_18:

   ld       hl, #_my_level18_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_19:

   ld       hl, #_my_level19_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa
   descomprimir_20:

   ld       hl, #_my_level20_pack_end
   ld       de, #decompress_buffer_end_level
   call     cpct_zx7b_decrunch_s_asm
   jp       terminar_descomprimir_mapa

   terminar_descomprimir_mapa:


ret




man_game_init::

   call     man_entity_init
   call     sys_render_init
   call     entityman_getEntityArray_IX
   call     entityman_getNumEntites_A
   call     sys_ai_control_init
   call     dibujar_tile
   ld       a, #8
   ld       (_my_last_direction), a

 


  ret
man_game_play::
    game_loop:
    SysUpdate ai_control
    SysUpdate physics
    SysUpdate collision_one_entity
    SysUpdate collision
    SysUpdate bullet
    call man_game_comprobar_disparo


    SysUpdate render

   .rept 130
      call cpct_waitVSYNC_asm
   .endm

   ld a, (_disparo_enemigo)
   inc a
   ld (_disparo_enemigo), a

   


    ld      a, (_vidas_ant)
    dec     a
    jp      z, exit

    ld      a,(_eggs)
    cp      #30;;numero de cocos para acabar el nivel
    jp      nz, game_loop

   ld    a, (estado_partida)
   inc a
   ld (estado_partida), a

   ld    a, #0
   ld    (_key), a
   ld    (_weapont), a
   ld    (_recamara), a

   ld       hl, #man_entity_destroy
   call     man_entity_forall

  

    ret

   exit:
   ld       hl, #man_entity_destroy
   call     man_entity_forall

   ld       a, (_vidas)
   dec      a  
   jp       nz, restart

   
  ;; ld a, #estado_partida
   ;;dec a
 
   ld a, #0
   ld (estado_partida), a

   escape:

   ret

   restart:
   ;; Comprobamos si llevamos arma. En caso afirmativo establecemos weapont a 2
   ld a, (_weapont)
   cp #0
   jr z, no_llevamos_arma

   ld a, (_weapont)
   ld (_recamara), a
   ld a, #0
   ld (_weapont), a

   no_llevamos_arma:
   ld       a, #2
   ld       (_vidas_ant), a
   
   ret

man_game_inc_vidas::

   ld       a, (_vidas)
   inc      a
   ld       (_vidas), a
   call     man_hud_vidas


ret

man_game_dec_vidas::
   ld       a, (_vidas)
   dec      a
   ld       (_vidas), a
   ld       a, #1
   ld       (_vidas_ant), a
   call     man_hud_vidas
   ret

man_game_inc_huevos::
   ld       a, (_eggs)
   inc      a
   ld       (_eggs), a
   call     man_hud_huevos
   ret

man_game_has_key::
   ld       a, (_key)
   inc      a
   ld       (_key), a
   call     man_hud_keys
   ret

man_game_lose_key::
   ld       a, (_key)
   dec      a
   ld       (_key), a
   call     man_hud_keys
   ret

man_game_restart_keys::
   ld             a, #0
   ld       (_key), a
   ret

man_game_restart_guns::
   ld             a, #0
   ld       (_weapont), a
   ret

man_game_restart_eggs::
   ld             a, #0
   ld       (_eggs), a
   ret

man_game_restart_lifes:

   ld a, #04
   ld (_vidas), a
   ld a, #02
   ld (_vidas_ant), a

ret

man_game_reinicio_juego::

   ld a, #05 
   ld (estado_partida), a

   ld a, #05
   ld (estado_partida_ant), a
   
   ld       a, #1
   ld       (_vidas_ant), a
   ld       (_vidas), a

ret

man_game_comprobar_disparo::

   ;;COMPROBAR QUE ES NIVEL

   ;;ld a, (estado_partida)
   ;;cp #1
   ;;jp nz, no_pium

   ld a, (_disparo_enemigo)
   cp #30
   jp nz, no_pium       ;;comprobamos q el contador ha llegado

   ld a, #0
   ld (_disparo_enemigo), a ;;incializamos contador a 0 

   call crear_bala_enemigo ;;llamamos a la bala




   no_pium:


ret

