;;  IMPORTANTE
;;  #_hola      -> Hacemos referencia a la direccion de memoria
;;  (_hola)     -> Hacemos referencia al contenido almacenado en esa direccion de memoria

.include "cpctelera.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"
.include "man/hud.h.s"
.include "sys/render.h.s"

str_x30:   .asciz  "x30"
str_x29:   .asciz  "x29"
str_x28:   .asciz  "x28"
str_x27:   .asciz  "x27"
str_x26:   .asciz  "x26"
str_x25:   .asciz  "x25"
str_x24:   .asciz  "x24"
str_x23:   .asciz  "x23"
str_x22:   .asciz  "x22"
str_x21:   .asciz  "x21"
str_x20:   .asciz  "x20"
str_x19:   .asciz  "x19"
str_x18:   .asciz  "x18"
str_x17:   .asciz  "x17"
str_x16:   .asciz  "x16"
str_x15:   .asciz  "x15"
str_x14:   .asciz  "x14"
str_x13:   .asciz  "x13"
str_x12:   .asciz  "x12"
str_x11:   .asciz  "x11"
str_x10:   .asciz  "x10"
str_x9:   .asciz  "x9"
str_x8:   .asciz  "x8"
str_x7:   .asciz  "x7"
str_x6:   .asciz  "x6"
str_x5:   .asciz  "x5"
str_x4:   .asciz  "x4"
str_x3:   .asciz  "x3"
str_x2:   .asciz  "x2"
str_x1:   .asciz  "x1"
str_x0:   .asciz  "x0"
str_de30:   .asciz  "/30"
str_lvl:   .asciz  "Level "


man_hud_init::
    call man_hud_sprites
    call man_hud_vidas
    call man_hud_huevos
    call man_hud_keys
    call man_hud_balas
    call man_hud_lvl

    ret
man_hud_vidas::
    push hl
    push af
    push iy
    ld      hl, #0x001
    call    cpct_setDrawCharM0_asm
    ld      a, (_vidas)
    dec     a
    cp      #7
    jp      z, v7
    cp      #6
    jp      z, v6
    cp      #5
    jp      z, v5
    cp      #4
    jp      z, v4
    cp      #3
    jp      z, v3
    cp      #2
    jp      z, v2
    cp      #1
    jp      z, v1
    ld      iy, #str_x0
    jp      end_vidas
    
    v7:
    ld      iy, #str_x7
    jp      end_vidas
    
    v6:
    ld      iy, #str_x6
    jp      end_vidas
    
    v5:
    ld      iy, #str_x5
    jp      end_vidas
    
    v4:
    ld      iy, #str_x4
    jp      end_vidas
    
    v3:
    ld      iy, #str_x3
    jp      end_vidas

    v2:
    ld      iy, #str_x2
    jp      end_vidas

    v1:
    ld      iy, #str_x1
    jp      end_vidas

    end_vidas:
    X = 52
    Y = 228
    ld      hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call    cpct_drawStringM0_asm
    pop hl
    pop af
    pop iy
    ret

man_hud_huevos::
    push hl
    push af
    push iy
    ld      hl, #0x001
    call    cpct_setDrawCharM0_asm
    ld      a, (_eggs)
    cp      #30
    jp      z, h30
    cp      #29
    jp      z, h29
    cp      #28
    jp      z, h28
    cp      #27
    jp      z, h27
    cp      #26
    jp      z, h26
    cp      #25
    jp      z, h25
    cp      #24
    jp      z, h24
    cp      #23
    jp      z, h23
    cp      #22
    jp      z, h22
    cp      #21
    jp      z, h21
    cp      #20
    jp      z, h20
    cp      #19
    jp      z, h19
    cp      #18
    jp      z, h18
    cp      #17
    jp      z, h17
    cp      #16
    jp      z, h16
    cp      #15
    jp      z, h15
    cp      #14
    jp      z, h14
    cp      #13
    jp      z, h13
    cp      #12
    jp      z, h12
    cp      #11
    jp      z, h11
    cp      #10
    jp      z, h10
    cp      #9
    jp      z, h9
    cp      #8
    jp      z, h8
    cp      #7
    jp      z, h7
    cp      #6
    jp      z, h6
    cp      #5
    jp      z, h5
    cp      #4
    jp      z, h4
    cp      #3
    jp      z, h3
    cp      #2
    jp      z, h2
    cp      #1
    jp      z, h1
    ld      iy, #str_x0
    jp      end_eggs
    
    h30:
    ld      iy, #str_x30
    jp      end_eggs
    
    h29:
    ld      iy, #str_x29
    jp      end_eggs
    
    h28:
    ld      iy, #str_x28
    jp      end_eggs
    
    h27:
    ld      iy, #str_x27
    jp      end_eggs
    
    h26:
    ld      iy, #str_x26
    jp      end_eggs

    h25:
    ld      iy, #str_x25
    jp      end_eggs

    h24:
    ld      iy, #str_x24
    jp      end_eggs
    h23:
    ld      iy, #str_x23
    jp      end_eggs
    
    h22:
    ld      iy, #str_x22
    jp      end_eggs
    
    h21:
    ld      iy, #str_x21
    jp      end_eggs
    
    h20:
    ld      iy, #str_x20
    jp      end_eggs
    
    h19:
    ld      iy, #str_x19
    jp      end_eggs

    h18:
    ld      iy, #str_x18
    jp      end_eggs

    h17:
    ld      iy, #str_x17
    jp      end_eggs
    h16:
    ld      iy, #str_x16
    jp      end_eggs
    
    h15:
    ld      iy, #str_x15
    jp      end_eggs
    
    h14:
    ld      iy, #str_x14
    jp      end_eggs
    
    h13:
    ld      iy, #str_x13
    jp      end_eggs
    
    h12:
    ld      iy, #str_x12
    jp      end_eggs

    h11:
    ld      iy, #str_x11
    jp      end_eggs

    h10:
    ld      iy, #str_x10
    jp      end_eggs
    h9:
    ld      iy, #str_x9
    jp      end_eggs
    
    h8:
    ld      iy, #str_x8
    jp      end_eggs
    
    h7:
    ld      iy, #str_x7
    jp      end_eggs
    
    h6:
    ld      iy, #str_x6
    jp      end_eggs
    
    h5:
    ld      iy, #str_x5
    jp      end_eggs

    h4:
    ld      iy, #str_x4
    jp      end_eggs

    h3:
    ld      iy, #str_x3
    jp      end_eggs

    h2:
    ld      iy, #str_x2
    jp      end_eggs

    h1:
    ld      iy, #str_x1
    jp      end_eggs

    end_eggs:
    X = 68
    Y = 228
    ld      hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call    cpct_drawStringM0_asm

    ld      hl, #0x001
    call    cpct_setDrawCharM0_asm
    ld      iy, #str_de30
    X = 80
    Y = 228
    ld      hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call    cpct_drawStringM0_asm
    pop hl
    pop af
    pop iy
    ret

man_hud_keys::
    push hl
    push af
    push iy
    ld      hl, #0x001
    call    cpct_setDrawCharM0_asm
    ld      a, (_key)
    cp      #5
    jp      z, k5
    cp      #4
    jp      z, k4
    cp      #3
    jp      z, k3
    cp      #2
    jp      z, k2
    cp      #1
    jp      z, k1
    ld      iy, #str_x0
    jp      end_keys
    
    k5:
    ld      iy, #str_x5
    jp      end_keys
    
    k4:
    ld      iy, #str_x4
    jp      end_keys
    
    k3:
    ld      iy, #str_x3
    jp      end_keys

    k2:
    ld      iy, #str_x2
    jp      end_keys

    k1:
    ld      iy, #str_x1
    jp      end_keys

    end_keys:
    X = 104
    Y = 228
    ld      hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call    cpct_drawStringM0_asm
    pop hl
    pop af
    pop iy
    ret

man_hud_balas::
    push hl
    push af
    push iy
    ld      hl, #0x001
    call    cpct_setDrawCharM0_asm
    ld      a, (_weapont)
    cp      #5
    jp      z, w5
    cp      #4
    jp      z, w4
    cp      #3
    jp      z, w3
    cp      #2
    jp      z, w2
    cp      #1
    jp      z, w1
    ld      iy, #str_x0
    jp      end_weapon
    
    w5:
    ld      iy, #str_x5
    jp      end_weapon
    
    w4:
    ld      iy, #str_x4
    jp      end_weapon
    
    w3:
    ld      iy, #str_x3
    jp      end_weapon

    w2:
    ld      iy, #str_x2
    jp      end_weapon

    w1:
    ld      iy, #str_x1
    jp      end_weapon

    end_weapon:
    X = 120
    Y = 228
    ld      hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call    cpct_drawStringM0_asm
    pop hl
    pop af
    pop iy
    ret

man_hud_lvl::
    push hl
    push af
    push iy
    ld      hl, #0x001
    call    cpct_setDrawCharM0_asm
    ld      a, (estado_partida)
    cp      #21
    jp      z, l21
    cp      #20
    jp      z, l20
    cp      #19
    jp      z, l19
    cp      #18
    jp      z, l18
    cp      #17
    jp      z, l17
    cp      #16
    jp      z, l16
    cp      #15
    jp      z, l15
    cp      #14
    jp      z, l14
    cp      #13
    jp      z, l13
    cp      #12
    jp      z, l12
    cp      #11
    jp      z, l11
    cp      #10
    jp      z, l10
    cp      #9
    jp      z, l9
    cp      #8
    jp      z, l8
    cp      #7
    jp      z, l7
    cp      #6
    jp      z, l6
    cp      #5
    jp      z, l5
    cp      #4
    jp      z, l4
    cp      #3
    jp      z, l3
    cp      #2
    jp      z, l2
    cp      #1
    jp      z, l1
    ld      iy, #str_x0
    jp      end_lvl
    
    l21:
    ld      iy, #str_x21
    jp      end_lvl
    
    l20:
    ld      iy, #str_x20
    jp      end_lvl
    
    l19:
    ld      iy, #str_x19
    jp      end_lvl

    l18:
    ld      iy, #str_x18
    jp      end_lvl

    l17:
    ld      iy, #str_x17
    jp      end_lvl
    l16:
    ld      iy, #str_x16
    jp      end_lvl
    
    l15:
    ld      iy, #str_x15
    jp      end_lvl
    
    l14:
    ld      iy, #str_x14
    jp      end_lvl
    
    l13:
    ld      iy, #str_x13
    jp      end_lvl
    
    l12:
    ld      iy, #str_x12
    jp      end_lvl

    l11:
    ld      iy, #str_x11
    jp      end_lvl

    l10:
    ld      iy, #str_x10
    jp      end_lvl
    l9:
    ld      iy, #str_x9
    jp      end_lvl
    
    l8:
    ld      iy, #str_x8
    jp      end_lvl
    
    l7:
    ld      iy, #str_x7
    jp      end_lvl
    
    l6:
    ld      iy, #str_x6
    jp      end_lvl
    
    l5:
    ld      iy, #str_x5
    jp      end_lvl

    l4:
    ld      iy, #str_x4
    jp      end_lvl

    l3:
    ld      iy, #str_x3
    jp      end_lvl

    l2:
    ld      iy, #str_x2
    jp      end_lvl

    l1:
    ld      iy, #str_x1
    jp      end_lvl

    end_lvl:
    X = 44
    Y = 4
    ld      hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call    cpct_drawStringM0_asm

    ld      hl, #0x001
    call    cpct_setDrawCharM0_asm
    ld      iy, #str_lvl
    X = 24
    Y = 4
    ld      hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call    cpct_drawStringM0_asm
    pop hl
    pop af
    pop iy
    ret
man_hud_sprites::
    push de
    push hl
    push bc
    push af
    push iy
    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  #0                          ;;  Posicion x de la entidad
    ld      b,  #188                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ex      de,     hl
    ld      hl, #_sprites
    ld      c,      #4
    ld      b,      #8
    call cpct_drawSprite_asm

    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  #16                          ;;  Posicion x de la entidad
    ld      b,  #188                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ex      de,     hl
    ld      hl, #_sprite_egg
    ld      c,      #4
    ld      b,      #8
    call cpct_drawSprite_asm

    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  #52                          ;;  Posicion x de la entidad
    ld      b,  #188                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ex      de,     hl
    ld      hl, #_sprite_key
    ld      c,      #4
    ld      b,      #8
    call cpct_drawSprite_asm

    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  #68                          ;;  Posicion x de la entidad
    ld      b,  #188                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ex      de,     hl
    ld      hl, #_sprite_gun
    ld      c,      #4
    ld      b,      #8
    call cpct_drawSprite_asm

    pop de
    pop hl
    pop bc
    pop af
    pop iy

    ret