;;MENU

.include "game.h.s"
;.include "cpct_functions.h.s"
.include "cpctelera.h.s"
.include "sys/render.h.s"
.include "man/entity.h.s"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_contador:: .db 0
_posicion:: .db 0
str_menu:   .asciz  "WATER TURTLE"
str_press:  .asciz  "Space to Start"

DefineEntity burbuja, 0, 0, 4, 8, 0, 8, 0x80, 0x00, 0x00, e_ai_st_no_ai

;;;;;;;;;;;;;;
;;PUBLIC FUNCTIONS
;;;;;;;;;;;;;;

;;;init
man_menu_init::
    ;;incializamos render modo 0 


    call sys_render_init
    call man_game_restart_eggs
    call man_game_restart_lifes

    ;;MENU STRING

    call man_menu_pintar_string
    call     descomprimir_mapa

   
    
    .rept 19
        ld      hl, #burbuja
        call man_entity_create
        ld      ix, (_last_elem_ptr)
        ld      bc, #-15
        add     ix, bc
        ld a, (_posicion)
        ld e_x(ix), a
        ld b, #4
        add a, b
        ld (_posicion), a
    .endm

        

    

    ld hl, #man_menu_randomizar
    call man_entity_forall

    
   

   

ret

;;RUN until finished
man_menu_run::

    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr nz,start_game

   

    
    ld a, (_contador)
    cp #500
    jp nz, no_actualiza     ;;comprobamos q el contador ha llegado

   ld a, #0
   ld (_contador), a ;;incializamos contador a 0 

   ;;llamamos a
    
    ld   hl, #sys_render_update
    call man_entity_forall

    ld   hl, #sys_physics_update
    call man_entity_forall

    call man_menu_pintar_string

    ld   hl, #man_menu_destruir
    call man_entity_forall



    no_actualiza:
    ld a, (_contador)
    inc a
    ld (_contador), a


    jp man_menu_run

    start_game:
    ld       hl, #man_entity_destroy
    call     man_entity_forall
ret

man_menu_destruir::

    ld a, e_y(ix)
    cp #200
    jp nz, saved 

    ld a, #0
    ld e_y(ix), a


    saved:

ret

man_menu_pintar_string::
    ld hl, #0x000A
    call cpct_setDrawCharM0_asm
    ld iy, #str_menu
    X = 16
    Y = 80
    ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call cpct_drawStringM0_asm

    ;;Press STRIN

    ld hl, #0x00007
    call cpct_setDrawCharM0_asm
    ld iy, #str_press
    X = 10
    Y = 120
    ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X ;;calculamos pos pantalla
    call cpct_drawStringM0_asm

ret

man_menu_randomizar::

        alea:
        ;; Establecemos posicion aleatoria
        call    cpct_getRandom_xsp40_u8_asm
        cp      #5 ;;Devuelve en A un valor de 0 a 3
        jr      nc, alea

        ld__e_ixl
        ld__d_ixh

        ld__iyl_e  ;;Guardamos la bala en iy porque el forall ira cogiendo el resto de entidades en ix
        ld__iyh_d

        ld      bc, #-15
        add     iy, bc
        ld b, e_y(iy)


        dec a
        jr z, unab
        dec a
        jr z, dosb
        dec a
        jr z, tresb
        dec a
        jr z, cuatrob
        unab:
        ld a, #96
        cp b
        jp z,alea
        ld e_y(ix), a
        jp cuatrob
        dosb:
        ld a, #48
        cp b
        jp z,alea
        ld e_y(ix), a
        jp cuatrob
        tresb:
        ld a, #144
        cp b
        jp z,alea
        ld e_y(ix), a
        cuatrob:
        ;;ld a, #0
        ;;cp b
        ;;jp z,alea


ret