;;  IMPORTANTE
;;  #_hola      -> Hacemos referencia a la direccion de memoria
;;  (_hola)     -> Hacemos referencia al contenido almacenado en esa direccion de memoria

.include "man/entity.h.s"
.include "sys/physics.h.s"
.include "collision.h.s"
.include "man/game.h.s"
.include "cpctelera.h.s"

.module collision

check_izda::
    ld      a, e_y(ix)
    srl     a
    srl     a
    srl     a
    ld      h, #0
    ld      l, a
    add     hl, hl
    add     hl, hl
    ld      d, h
    ld      e, l
    add     hl, hl
    add     hl, hl
    add     hl, de

    ld      a, e_x(ix)
    sub     #4
    srl     a
    srl     a

    add_hl_a

    ld  a, (estado_partida)
    cp  #2
    jp  nz, unosiizda
    ld de, #mapa_ptr
    jp saltoizda
    unosiizda:
    cp #3
    jp nz, no_es_tresizda
    
    ld de, #mapa_ptr
    jp saltoizda

    no_es_tresizda:
    cp #4
    jp nz, no_es_cuatroizda
    ld de, #mapa_ptr
    jp saltoizda

    no_es_cuatroizda:
    ld de, #mapa_ptr


    saltoizda:
    add     hl, de
    ld      a, (hl)
    and     #0xF8
    jp     nz, siizda

    ld      a, (hl)
    and     #0xFD
    jp      nz, noizda
    
    ld      a, (_key)
    cp      #0
    jp      z, noizda

    jp      siizda

    noizda:
    ld      b, #1
    jp      fueizda
    siizda:
    ld      b, #2
    fueizda:
    ret

check_dcha::
    ld      a, e_y(ix)
    srl     a
    srl     a
    srl     a
    ld      h, #0
    ld      l, a
    add     hl, hl
    add     hl, hl
    ld      d, h
    ld      e, l
    add     hl, hl
    add     hl, hl
    add     hl, de

    ld      a, e_x(ix)
    add     #4
    srl     a
    srl     a

    add_hl_a

    ld  a, (estado_partida)
    cp  #2
    jp  nz, unosidcha
    ld de, #mapa_ptr
    jp saltodcha
    unosidcha:
    cp #3
    jp nz, no_es_tresdcha
    
    ld de, #mapa_ptr
    jp saltodcha

    no_es_tresdcha:
    cp #4
    jp nz, no_es_cuatrodcha
    ld de, #mapa_ptr
    jp saltodcha

    no_es_cuatrodcha:
    ld de, #mapa_ptr


    saltodcha:
    add     hl, de
    ld      a, (hl)
    and     #0xF8
    jp     nz, sidcha

    ld      a, (hl)
    and     #0xFD
    jp      nz, nodcha
    
    ld      a, (_key)
    cp      #0
    jp      z, nodcha

    jp      sidcha

    nodcha:
    ld      b, #1
    jp      fuedcha
    sidcha:
    ld      b, #2
    fuedcha:
    ret

check_up::
    ld      a, e_y(ix)
    sub     #8
    srl     a
    srl     a
    srl     a
    ld      h, #0
    ld      l, a
    add     hl, hl
    add     hl, hl
    ld      d, h
    ld      e, l
    add     hl, hl
    add     hl, hl
    add     hl, de

    ld      a, e_x(ix)
    srl     a
    srl     a

    add_hl_a

    ld  a, (estado_partida)
    cp  #2
    jp  nz, unosiup
    ld de, #mapa_ptr
    jp saltoup
    unosiup:
    cp #3
    jp nz, no_es_tresup
    
    ld de, #mapa_ptr
    jp saltoup

    no_es_tresup:
    cp #4
    jp nz, no_es_cuatroup
    ld de, #mapa_ptr
    jp saltoup

    no_es_cuatroup:
    ld de, #mapa_ptr


    saltoup:
    add     hl, de
    ld      a, (hl)
    and     #0xF8
    jp     nz, siup

    ld      a, (hl)
    and     #0xFD
    jp      nz, noup
    
    ld      a, (_key)
    cp      #0
    jp      z, noup

    jp      siup

    noup:
    ld      b, #1
    jp      fueup
    siup:
    ld      b, #2
    fueup:
    ret

check_down::
    ld      a, e_y(ix)
    add     #8
    srl     a
    srl     a
    srl     a
    ld      h, #0
    ld      l, a
    add     hl, hl
    add     hl, hl
    ld      d, h
    ld      e, l
    add     hl, hl
    add     hl, hl
    add     hl, de

    ld      a, e_x(ix)
    srl     a
    srl     a

    add_hl_a

    ld  a, (estado_partida)
    cp  #2
    jp  nz, unosidown
    ld de, #mapa_ptr
    jp saltodown
    unosidown:
    cp #3
    jp nz, no_es_tresdown
    
    ld de, #mapa_ptr
    jp saltodown

    no_es_tresdown:
    cp #4
    jp nz, no_es_cuatrodown
    ld de, #mapa_ptr
    jp saltodown

    no_es_cuatrodown:
    ld de, #mapa_ptr


    saltodown:
    add     hl, de
    ld      a, (hl)
    and     #0xF8
    jp     nz, sidown

    ld      a, (hl)
    and     #0xFD
    jp      nz, nodown
    
    ld      a, (_key)
    cp      #0
    jp      z, nodown

    jp      sidown

    nodown:
    ld      b, #1
    jp      fuedown
    sidown:
    ld      b, #2
    fuedown:
    ret


sys_collision_one_entity_update::

    
    ld      a, e_type(ix)
    and     #e_type_player
    jp      z, sale

    ld      a, e_y(ix)
    srl     a
    srl     a
    srl     a
    ld      h, #0
    ld      l, a
    add     hl, hl
    add     hl, hl
    ld      d, h
    ld      e, l
    add     hl, hl
    add     hl, hl
    add     hl, de

    ld      a, e_x(ix)
    srl     a
    srl     a

    add_hl_a

    ld de, #mapa_ptr

    salto:

    ;ld      de, #mapa_ptr
    add     hl, de

    ld      a, (hl)
    and     #0xF8
    jp      nz, nopared

    ld      a, #2
    ld      (_slip), a


    ld      a, (hl)
    and     #0xFD
    jp      nz, return
    
    ld      a, (_key)
    cp #0
    jp      z, return

    ld      (hl), #17 
    call    man_game_lose_key

    jp sale

    return:

    ;;Colision detectada
    ld a, e_y(ix) ;;a tenemos POSY
    sub e_yant(ix) ;; RESTAMOS: posY - posantY
    jr z,saley

    saley:
    ld a,  e_yant(ix)
    ld e_y(ix), a

    ld a, e_x(ix) ;;a tenemos POSY
    sub e_xant(ix) ;; RESTAMOS: posY - posantY
    jr z,salex

    salex:
    ld a,  e_xant(ix)
    ld e_x(ix), a
    jp sale
    nopared:
    ld      a, (hl)
    and     #0xF6
    jp z, huevo

    ld      a, (hl)
    and     #0xF5
    jp      z, llave

    ld      a, (hl)
    and     #0xF4                   ;;Comprobamos si hay un 10 en el mapa (sería una pistola)
    jp z, coger_arma

    ld      a, (hl)
    and     #0xF3
    jp z, slip

    ld      a, (hl)
    and     #0xF2                  ;;El tileset debe ser un 9
    jp z, mas_vidas

    ld      a, #2
    ld      (_slip), a

    jp sale
    huevo:

    ;;colisiona con un huevo
    ld (hl), #17 
    ld      a, #2
    ld      (_slip), a
    call man_game_inc_huevos
    jr sale

    slip:
    ;;colisiona con una llave
    ld      (hl), #17 
    ld      a, #1
    ld      (_slip), a
    jp      sale


    mas_vidas:
    ld      a, #2
    ld      (_slip), a
    ld (hl), #17
    call man_game_inc_vidas
    jp sale


    llave:
    ;;colisiona con una llave
    ld      (hl), #17 
    ld      a, #2
    ld      (_slip), a
    call    man_game_has_key
    jp      sale

    coger_arma:
    ld      a, #2
    ld      (_slip), a
        
    ld (hl), #17                    ;;Sustituimos el dibujo de la pistola por el suelo
    ld a, (_weapont)
    inc a
    ld (_weapont), a            ;;Cogemos la pistola
    call man_hud_balas
    ;;call crear_bala





    sale:

    call enemy_collision

    call bullet_collision

    ret

bullet_collision:

    ld      a, e_type(ix)
    and     #e_type_bullet
    ret     z


    ;;COMPROBAMOS TILEMAP
     ld      a, e_y(ix)
    srl     a
    srl     a
    srl     a
    ld      h, #0
    ld      l, a
    add     hl, hl
    add     hl, hl
    ld      d, h
    ld      e, l
    add     hl, hl
    add     hl, hl
    add     hl, de

    ld      a, e_x(ix)
    srl     a
    srl     a

    add_hl_a

    ld de, #mapa_ptr

    saltob:
    ;;ld      de, #mapa_ptr
    add     hl, de

    ld      a, (hl)
    and     #0xF8
    ret     nz

    ;;HA COLISIONADO PARED
    call man_entity_destroy_ix
ret
enemy_collision::

    ld      a, e_type(ix)
    and     #e_type_enemy
    ret     z

    ld      a, e_y(ix)
    srl     a
    srl     a
    srl     a
    ld      h, #0
    ld      l, a
    add     hl, hl
    add     hl, hl
    ld      d, h
    ld      e, l
    add     hl, hl
    add     hl, hl
    add     hl, de

    ld      a, e_x(ix)
    srl     a
    srl     a

    add_hl_a

    ld de, #mapa_ptr





    saltoe:
    ;;ld      de, #mapa_ptr
    add     hl, de

    ld      a, (hl)
    and     #0xF8
    ret     nz

    ;;Si colisiona el enemigo con la pared

    ;;Colision detectada
    ld a, e_y(ix) ;;a tenemos POSY
    sub e_yant(ix) ;; RESTAMOS: posY - posantY
    jr z,saley_enemy

    saley_enemy:
    ld a,  e_yant(ix)
    ld e_y(ix), a
    ld e_vy(ix), #0

    ld a, e_x(ix) ;;a tenemos POSY
    sub e_xant(ix) ;; RESTAMOS: posY - posantY
    jr z,salex_enemy

    salex_enemy:
    ld a,  e_xant(ix)
    ld e_x(ix), a
    ld e_vx(ix), #0
    
    aleatorio:
    ;; Establecemos velocidad aleatoria
    call    cpct_getRandom_xsp40_u8_asm
    cp     #5 ;;Devuelve en A un valor de 0 a 3
    jr      nc, aleatorio
    dec a
    jr z, izq
    dec a
    jr z, der
    dec a
    jr z, up
    dec a
    jr z, down


    izq:
    ld e_vx(ix), #-4
    jr terminar_vel
    der:
    ld e_vx(ix), #4
    jr terminar_vel
    up:
    ld e_vy(ix), #-8
    jr terminar_vel
    down:
    ld e_vy(ix), #8

    terminar_vel:



ret




sys_collision_update::
    ld      a, (_num_entities)
    dec     a
    jr      z, _no_collision

    ld      a, e_type(ix)
    and     #e_type_player
    jp      nz, _no_collision


    ld      hl, #_entity_array

    ld      e, l
    ld      d,h

    ld__iyl_e  ;;Guardamos el player en iy porque el forall ira cogiendo el resto de entidades en ix
    ld__iyh_d

    ld      a, e_type(iy)
    and     #e_type_player
    jp      z, _no_collision

    call sys_collision_check
    jr      nz, _no_collision

    _is_colliding:

    ld      a, e_type(ix)
    and     #e_type_enemy
    jp      nz, destroy_player

    destroy_player:

    ;;Game over
    call man_game_dec_vidas

    jr continue

    continue:

    _no_collision:

    ret


sys_collision_check::
    ld      a, e_x(ix)
    sub     e_x(iy)
    ret     nz

    ld      a, e_x(iy)
    sub     e_x(ix)
    ret     nz

    ld      a, e_y(ix)
    sub     e_y(iy)
    ret     nz

    ld      a, e_y(iy)
    sub     e_y(ix)
    

    ret

sys_bullet_update::

    ld      a, e_type(ix)
    and     #e_type_bullet
    jp      z, no_es_bullet

    ;;detecta la bala (CHECKED)
    
    ld__e_ixl
    ld__d_ixh

    ld__iyl_e  ;;Guardamos la bala en iy porque el forall ira cogiendo el resto de entidades en ix
    ld__iyh_d


    ld   hl, #sys_collision_bullet
    call man_entity_forall
  
    no_es_bullet:

ret

sys_collision_bullet::
;;EN IY TENEMOS LA BULLET, EN IX IREMOS RECORRIENDO TODAS LAS ENTIDADES
;;ver si el enemigo colisiona con la bullet y destruirlo

    ld      a, e_type(ix)
    and     #e_type_enemy
    jp      z, _no_hay_collision

    ld a, e_type(ix)

    call sys_comprobar_collision
    jr      nz, _no_hay_collision

    
    ld b, e_type(ix)
   

    ;;HA COLISIONADO Y ES ENEMIGO DETECTADO CHECKEDDDDDDD SI JODERERRRRR
    ;;eliminar enemigo
    ;;eliminar bala
    call man_entity_destroy_bullet
    call man_entity_destroy_ix
   
    

    _no_hay_collision:

ret

sys_comprobar_collision::

    ld b, e_x(ix)
    
    ld a, e_x(iy)
    cp e_x(ix)
    jp z, misma_x_checked

    comprobar_y:
    ld a, e_y(iy)
    cp e_y(ix)
    jp z, misma_y_checked
    jp nono

    misma_x_checked:

    ld a, e_y(iy)
    cp e_y(ix)
    jp z, misma_y_x
    
    ld a, e_y(iy)
    add #8
    cp e_y(ix)
    jp z, misma_y_x

    ld a, e_y(iy)
    add #-8
    cp e_y(ix)
    jp nz, nono

    misma_y_checked:
    ld a, e_x(iy)
    cp e_x(ix)
    jp z, misma_y_x
    
    ld a, e_x(iy)
    add #4
    cp e_x(ix)
    jp z, misma_y_x

    ld a, e_x(iy)
    add #-4
    cp e_x(ix)
    jp nz, nono
    
    misma_y_x:
    ret 
    nono:
ret nz
    