;;  IMPORTANTE
;;  #_hola      -> Hacemos referencia a la direccion de memoria
;;  (_hola)     -> Hacemos referencia al contenido almacenado en esa direccion de memoria

.include "physics.h.s"
.include "man/entity.h.s"
.include "cpctelera.h.s"
.include "keyboard/keyboard.h.s"

_lockDir:: .db 0 ;;0/Nada ;;1/Izda ;;2/Dcha ;;3/Up ;;4/Down

sys_physics_update::

    ld      a, e_type(ix)
    and     #e_type_player
    jp      nz, tipoPlayer
    jr no_mover_tipoPlayer

    tipoPlayer:
    call mover_player

    no_mover_tipoPlayer:
    ld      a, e_type(ix)
    and     #e_type_enemy
    jp      z, otro_tipo

    ld b, e_vx(ix)
    ld a, e_x(ix)
    ld e_xant(ix), a
    add a, b
    ld e_x(ix), a
    

    ld b, e_vy(ix)
    ld a, e_y(ix)
    ld e_yant(ix), a
    add a, b
    ld e_y(ix), a

    otro_tipo:
    ld      a, e_type(ix)
    and     #e_type_bullet
    jp      z, bubble
    ld b, e_vx(ix)
    ld a, e_x(ix)
    ld e_xant(ix), a
    add a, b
    ld e_x(ix), a

    ld b, e_vy(ix)
    ld a, e_y(ix)
    ld e_yant(ix), a
    add a, b
    ld e_y(ix), a
    
    bubble:
    ld      a, e_type(ix)
    and     #e_type_bubble
    jp      z, continuar
    ld b, e_vx(ix)
    ld a, e_x(ix)
    ld e_xant(ix), a
    add a, b
    ld e_x(ix), a

    ld b, e_vy(ix)
    ld a, e_y(ix)
    ld e_yant(ix), a
    add a, b
    ld e_y(ix), a

    continuar:
    

    ret

mover_player::

    ld      a, (_slip)
    cp      #2
    jp      nz, no_escp

    call cpct_scanKeyboard_asm
    jp z, jugando

    ld a, #0
    ld (_lockDir), a
    jp fuera

    jugando:

    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    cp #0
    jr z, no_escp

    ;;ha apretado espacio
    call man_game_reinicio_juego

    no_escp:


    ld hl, #Key_N
    call cpct_isKeyPressed_asm
    cp #0
    jr z, no_next_level

    ;;ld a, #30
    ;;ld (_eggs), a

    no_next_level:
    
    



    ld      a, (_lockDir)
    cp      #4
    jp      z, comprobacionDown
    ld      a, (_lockDir)
    cp      #3
    jp      z, comprobacionUp
    ld      a, (_lockDir)
    cp      #2
    jp      z, comprobacionDcha
    ld      a, (_lockDir)
    cp      #1
    jp      z, comprobacionIzda
    jp      inicio

    comprobacionDown:

    ld      a, (_slip)
    cp      #2
    jp      nz, directo_down

    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    cp #0
    jp z, inicio

    directo_down:
    call check_down
    ld a, b
    cp #2
    jp nz, inicio

    ld a, e_y(ix)
    ld e_yant(ix),a
    ld a, #8
    add a, e_y(ix)
    ld e_y(ix), a
    ld a, e_x(ix)
    ld e_xant(ix), a
    ld a, #2                                ;; El 2 es abajo en teclado numerico
    ld (_my_last_direction), a
    ld a, #4
    ld (_lockDir), a
    jp fuera

    comprobacionUp:

    ld      a, (_slip)
    cp      #2
    jp      nz, directo_up

    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    cp #0
    jp z, inicio

    directo_up:
    call check_up
    ld a, b
    cp #2
    jp nz, inicio

    ld a, e_y(ix)
    ld e_yant(ix),a
    ld a, #-8
    add a, e_y(ix)
    ld e_y(ix), a
    ld a, e_x(ix)
    ld e_xant(ix), a
    ld a, #8                                ;; El 4 es arriba en teclado numerico
    ld (_my_last_direction), a
    ld a, #3
    ld (_lockDir), a
    jp fuera

    comprobacionDcha:

    ld      a, (_slip)
    cp      #2
    jp      nz, directo_dcha

    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    cp #0
    jp z, inicio

    directo_dcha:
    call check_dcha
    ld a, b
    cp #2
    jp nz, inicio

    ld a, e_x(ix)
    ld e_xant(ix),a
    ld a, #4
    add a, e_x(ix)
    ld e_x(ix), a
    ld a, e_y(ix)
    ld e_yant(ix), a
    ld a, #6                                ;; El 6 es der en teclado numerico
    ld (_my_last_direction), a
    ld a, #2
    ld (_lockDir), a
    jp fuera

    comprobacionIzda:

    ld      a, (_slip)
    cp      #2
    jp      nz, directo_izda

    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    cp #0
    jp z, inicio

    directo_izda:
    call check_izda
    ld a, b
    cp #2
    jp nz, inicio

    ld a, e_x(ix)
    ld e_xant(ix),a
    ld a, #-4
    add a, e_x(ix)
    ld e_x(ix), a
    ld a, e_y(ix)
    ld e_yant(ix), a
    ld a, #4                                ;; El 4 es izq en teclado numerico
    ld (_my_last_direction), a
    ld a, #1
    ld (_lockDir), a
    jp fuera


    inicio:
    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    cp #0
    jr z, no_izq

        call check_izda
        ld a, b
        cp #2
        jp nz, no_izq

        ld a, e_x(ix)
        ld e_xant(ix),a
        ld a, #-4
        add a, e_x(ix)
        ld e_x(ix), a
        ld a, e_y(ix)
        ld e_yant(ix), a
        ld a, #4                                ;; El 4 es izq en teclado numerico
        ld (_my_last_direction), a
        ld a, #1
        ld (_lockDir), a
        jp fuera

    no_izq:

    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    cp #0
    jr z, no_dch

        call check_dcha
        ld a, b
        cp #2
        jp nz, no_dch

        ld a, e_x(ix)
        ld e_xant(ix),a
        ld a, #4
        add a, e_x(ix)
        ld e_x(ix), a
        ld a, e_y(ix)
        ld e_yant(ix), a
        ld a, #6                                ;; El 6 es der en teclado numerico
        ld (_my_last_direction), a
        ld a, #2
        ld (_lockDir), a
        jp fuera

    no_dch:

    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    cp #0
    jr z, no_up

        call check_up
        ld a, b
        cp #2
        jp nz, no_up

        ld a, e_y(ix)
        ld e_yant(ix),a
        ld a, #-8
        add a, e_y(ix)
        ld e_y(ix), a
        ld a, e_x(ix)
        ld e_xant(ix), a
        ld a, #8                                ;; El 4 es arriba en teclado numerico
        ld (_my_last_direction), a
        ld a, #3
        ld (_lockDir), a
        jp fuera
    
    no_up:

    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    cp #0
    jr z, no_down

        call check_down
        ld a, b
        cp #2
        jp nz, no_down

        ld a, e_y(ix)
        ld e_yant(ix),a
        ld a, #8
        add a, e_y(ix)
        ld e_y(ix), a
        ld a, e_x(ix)
        ld e_xant(ix), a
        ld a, #2                                ;; El 2 es abajo en teclado numerico
        ld (_my_last_direction), a
        ld a, #4
        ld (_lockDir), a
        jp fuera

        

    no_down:

    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    cp #0
    jr z, fuera

        ld a,  (_recamara)
        cp #0
        jr nz, cargamos_bala
        jr continuar_disparo

        cargamos_bala:
        ld a, (_recamara)
        ld (_weapont), a
        ld a, #0
        ld (_recamara), a
        jr fuera

        continuar_disparo:

        ld a, (_weapont)
        cp #0
        jp z, fuera
        dec a
        ld (_weapont), a
        call crear_bala
        call man_hud_balas
        

    ld a, #0
    ld (_lockDir), a
    jp fuera

    slippering:
    ld      a, (_lockDir)
    cp      #4
    jp      z, comprobacionDown
    ld      a, (_lockDir)
    cp      #3
    jp      z, comprobacionUp
    ld      a, (_lockDir)
    cp      #2
    jp      z, comprobacionDcha
    ld      a, (_lockDir)
    cp      #1
    jp      z, comprobacionIzda
    jp      fuera
    fuera:

ret

sys_physics_collision:

    mov_ejex: 

    ld a, e_x(ix) ;;a tenemos POSX
    sub e_xant(ix) ;; RESTAMOS: posX - posantX
    ;;Si da 0 no se mueve eje X
    jr z,mov_ejey

    
    ld a,  e_xant(ix)
    ld e_x(ix), a
    

    

    mov_ejey:
    ld a, e_y(ix) ;;a tenemos POSY
    sub e_yant(ix) ;; RESTAMOS: posY - posantY

    jr z,no_mov
    ld a,  e_yant(ix)
    ld e_y(ix), a

    no_mov:

ret