;;  IMPORTANTE
;;  #_hola      -> Hacemos referencia a la direccion de memoria
;;  (_hola)     -> Hacemos referencia al contenido almacenado en esa direccion de memoria

.include "render.h.s"
.include "man/entity.h.s"
.include "cpctelera.h.s"

;;.globl _tiles_00
;;.globl _tilemap_01
;;.globl _tilemap_2
;;.globl _tilemap_3
.globl _hwpalette
.globl _sprites
.globl _spritesD
.globl _spritesR
.globl _spritesL
.globl _balasprite
.globl _enemys
;;.globl _sprite_palette


sprite_egg:
	.db 0xFF, 0xFF
	.db 0xFF, 0xFF

sprite_bullet:
	.db 0x0A, 0x0A
	.db 0x0A, 0x0A

sprite_wall:
	.db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00
    .db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00
    .db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00
    .db 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x00
    

.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_setVideoMode_asm
.globl cpct_setPalette_asm
.globl cpct_drawSprite_asm
;.globl cpct_etm_setDrawSprite4x8_ag_asm
;.globl cpct_etm_drawTilemap4x8_ag_asm


sys_render_init::

    ld      c,  #0
    call    cpct_setVideoMode_asm

    cpctm_setBorder_asm HW_BLUE
    ld      hl, #_hwpalette
    ld      de, #16
    call    cpct_setPalette_asm

    cpctm_clearScreen_asm HW_WHITE

    ;;ld de, #0xC000
    ;;ld a, #0x00
    ;;ld c, #60
    ;;ld b, #200
    ;;call cpct_drawSolidBox_asm

    

    ;;ld c, #40;;width
    ;;ld b, #25;;height
    ;;ld de, #4000 ;;width del tilemap completo
    ;;ld hl, #_tiles_0
;;
    ;;call cpct_etm_setDrawTilemap4x8_ag_asm
;;
    ;;ld hl, #0xC000
    ;;ld de, #0x40E0
;;
;;
    ;;call cpct_etm_drawTilemap4x8_ag_asm


    ret






sys_render_update::


    ;;  Calculamos la posicion donde queremos pintar
    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  e_x(ix)                       ;;  Posicion x de la entidad
    ld      b,  e_y(ix)                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ex      de,     hl
    ld      a, e_type(ix)
    and     #e_type_player
    jp      nz, tipoPlayer
    ld      a, e_type(ix)
    and     #e_type_egg
    jp      nz, tipoEgg
    ld      a, e_type(ix)
    and     #e_type_enemy
    jp      nz, tipoEnemy
    ld      a, e_type(ix)
    and     #e_type_wall
    jp      nz, tipoWall

    ld      a, e_type(ix)
    and     #e_type_bullet
    jp      nz, tipoBullet

    ld      a, e_type(ix)
    and     #e_type_bubble
    jp      nz, tipoBubble
    jr continuar

    tipoPlayer:

    ld a, (_my_last_direction)
    cp #4
    jp z, tortu_izq
    ld a, (_my_last_direction)
    cp #6
    jp z, tortu_der
    ld a, (_my_last_direction)
    cp #8
    jp z, tortu_arriba

    ld      hl, #_spritesD
    jr      continuar

    tortu_izq:
    ld      hl, #_spritesL
    jr      continuar
    tortu_der:
    ld      hl, #_spritesR
    jr      continuar
    tortu_arriba:
    ld      hl, #_sprites
    jr      continuar

    tipoEgg:
    ld      hl, #sprite_egg
    jr      continuar

    tipoEnemy:
    ld      hl, #_enemys
    jr      continuar

    tipoWall:
    ld      hl, #sprite_wall
    jr      continuar

    tipoBullet:
    ld      hl, #sprite_bullet
    jr      continuar

    tipoBubble:
    ld      hl, #_balasprite


    continuar:
    ld      c,      e_w(ix)
    ld      b,      e_h(ix)

    call cpct_drawSprite_asm
    
    ld      a, e_x(ix)
    sub     e_xant(ix)
    jp      nz, black
    ld      a, e_y(ix)
    sub     e_yant(ix)
    jp      nz, black
    jp      noblack

    black:
    ;;  Calculamos la posicion donde queremos pintar
    ld      de, #0xC000                       ;;  Hacemos que empiece en la segunda memoria de video
    ld      c,  e_xant(ix)                       ;;  Posicion x de la entidad
    ld      b,  e_yant(ix)                       ;;  Posicion y de la entidad. Cargamos lo que hay en ix y le sumamos 1
    call    cpct_getScreenPtr_asm           ;;  Convierte las posiciones (x,y) en la posición de pantalla

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ex      de,     hl
    ld      hl, #sprite_wall
    ld      c,      e_w(ix)
    ld      b,      e_h(ix)

    call cpct_drawSprite_asm

    noblack:
    ret

dibujar_tile::


    ;;ld bc, #0xhhww    Él pone: 0x1010            ->16 de alto y de ancho de la pantalla en modo 0
    ;;ld de, #0xtmw     Él pone: 0x30              ->48 su tilemap total
    ld c, #20;;width
    ld b, #25;;height
    ld de, #20 ;;width del tilemap completo


    ld hl, #tileset_ptr

    call cpct_etm_setDrawTilemap4x8_ag_asm

    ld hl, #0xC000
    
    ld de, #mapa_ptr

    call cpct_etm_drawTilemap4x8_ag_asm

ret